#!/bin/sh

export PGDATA=/usr/local/pgsql/data
prefix=/usr/local/pgsql/bin

startpg(){
    pid=`/sbin/pidof -s postmaster`
    if [ $pid ]; then
        echo "Postmaster already running."
    else
        rm -f /tmp/.s.PGSQL.* > /dev/null
        # -wIvVDBgpɂȂ܂ő҂
        su -l postgres -s /bin/sh -c "$prefix/pg_ctl -w -D $PGDATA start  > /dev/null 2>&1" < /dev/null
        sleep 1
        pid=`/sbin/pidof -s postmaster`
        if [ $pid ]; then
            touch /var/lock/subsys/postgresql
            echo $pid > /var/run/postmaster.pid
        fi
    fi
}

stoppg(){
    shutdown_method=$1
    su -l postgres -s /bin/sh -c "$prefix/pg_ctl stop -D $PGDATA -s -m $shutdown_method" > /dev/null 2>&1
    ret=$?
    rm -f /var/run/postmaster.pid
    rm -f /var/lock/subsys/postgresql
    return $ret
}

stoppgretry(){
    stoppg fast
    if [ $? -ne 0 ]; then
        #IȂƂ̂߂ɋI݂
        stoppg immediate
    fi
}

restartpg(){
    #mɏI
    stoppgretry
    #NDBANZX\ɂȂ̂҂
    startpg
}

case $1 in
    start)
        startpg
        ;;
    stop)
        stoppgretry
        ;;
    restart)
        restartpg
        ;;
    *)
        echo "Usage $0 {start|stop|restart}" 1>&2
        exit 1
        ;;
esac